
/*
 * md5wrapper.c
 *
 *	signature function hook for MD5 (the RSA Data Security, Inc. MD5 
 *	Message Digesting Algorithm) for Tripwire.
 *
 *	The original MD5 code is contained in md5.c in its entirety.
 *
 * Gene Kim
 * Purdue University
 * September 27, 1992
 */

#include <stdio.h>
#include <sys/types.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include "sigs.h"
#include "md5.h"
#define BUFSIZE 4096

static MD5_CTX mdbucket;			/* MD5 data structure */

char *btob64();

/*
 * int
 * pf_signature(int fd_in, char *ps_signature, int siglen)
 *
 *	fd_in: 		pointer to input file descriptor
 *	ps_signature: 	pointer to array where signature will be stored
 *	siglen: 	length of the signature array (for overflow checking)
 */

int 
sig_md5_get (sig_text,ps_signature, siglen)
    char *sig_text;
    char *ps_signature;
    int siglen; 
{
    unsigned char buffer[BUFSIZE];
    int		readin;
    int 	i;
    MD5_CTX	*mdbuf;
    char	s[128];

    if (strlen(sig_text) <=0) 
    	return -1;

    mdbuf = &mdbucket;

    ps_signature[0] = '\0';
     
    MD5Init (mdbuf);

	MD5Update(mdbuf, sig_text, strlen(sig_text));

    MD5Final (mdbuf);

	for (i = 0; i < 16; i++) {

#if (TW_TYPE32 == int)
	    sprintf (s, "%02x", mdbuf->digest[i]);
#else
	    sprintf (s, "%02lx", mdbuf->digest[i]);
#endif
	    strcat(ps_signature, s);
	}
    /* base 64 */
    return 0;
}
int md5_str(const char *instr,char *series)
{
	int i;
	char buffer[64];

	memset(buffer,'\0',64);
	if ( sig_md5_get(instr,buffer,64) <0 )
		return -1;

	memset(series,'\0',64);
	strncpy(series,buffer,32);
	return 0;
}

